﻿using System;
using Kernel.Services;

namespace Kernel
{
    public class Field<T>
    {
        private T m_value;
        private Validator<T> m_validator;

        public T Value
        {
            get { return this.m_value; }
            set
            {
                // *** IF THIS IS NULL THE FIELD DOES NOT REQUIRE VALIDATION ***
                // *** FOR EXAMPLE A BOOLEAN FIELD WONT ENED VALIDATION ***
                if (m_validator != null)
                {
                    if (!m_validator.Validate(value))
                    {
                        throw new ArgumentException();
                    }
                }
                m_value = value;
            }
        }

        public Field(Validator<T> validator)
        {
            m_validator = validator;
        }
    }
}
