﻿using System;

namespace Kernel.Services
{
    public class LengthValidator : Validator<string>
    {
        private int m_minLength;
        private int m_maxLength;

        public LengthValidator(int p_min, int p_max)
        {
            m_minLength = p_min;
            m_maxLength = p_max;
        }

        public override bool Validate(string p_string)
        {
            if (string.IsNullOrEmpty(p_string))
            {
                throw new ArgumentNullException();
            }

            if ((p_string.Length < m_minLength) || (p_string.Length > m_maxLength))
            {
                throw new ArgumentOutOfRangeException();
            }
            return true;
        }
    }
}
