﻿using System;

namespace Kernel.Services
{
    public class RangeValidator : Validator<int>
    {
        private int m_LBound;
        private int m_UBound;

        public RangeValidator(int p_min, int p_max)
        {
            m_LBound = p_min;
            m_UBound = p_max;
        }

        public override bool Validate(int p_int)
        {
            if ((p_int < m_LBound) || (p_int > m_UBound))
            {
                throw new ArgumentOutOfRangeException();
            }
            return true;
        }

    }
}
